> ## Documentation Index
> Fetch the complete documentation index at: https://docs.chkk.io/llms.txt
> Use this file to discover all available pages before exploring further.

# List Resources

> List multiple KubeClusterResources

A KubeCluster can have many <em>KubeClusterResources</em>. Each time a
KubeCluster's inventory is scanned, one or more KubeClusterResources are
created for the KubeCluster and scan date.

KubeClusterResource represents a single Resource (Deployment,
Daemonset, StatefulSet, etc) installed in a specific namespace in
the KubeCluster.

A KubeClusterResource <em>may</em> be assigned a known KubeDeploymentSystem.
When the KubeClusterResource's DeploymentSystem field is empty, that means that
the classification process was unable to determine a matching
KubeDeploymentSystem for the discovered Resource.

A KubeClusterResource <em>may</em> be assigned a known PackageSystem. When the
KubeClusterResource's PackageSystem field is empty, that means that the
classification process was unable to determine a matching PackageSystem for the
discovered Resource.

A KubeClusterResource <em>may</em> be associated with a known Package. When the
KubeClusterResource's Package field is empty, that means that the
classification process was unable to determine a matching Package for the
discovered Resource.

A KubeClusterResource <em>may</em> be associated with a known PackageComponent.
When the KubeClusterResource's PackageComponent field is empty, that means that
the classification process was unable to determine a matching PackageComponent
for the discovered Resource.




## OpenAPI

````yaml get /kubeclusters/{cluster}/resources
openapi: 3.1.0
info:
  description: >

    The Chkk Artifact Register API exposes information about the artifacts in a

    customer's clusters.


    Data models exposed in the Chkk Artifact Register API include:


    * <b>Organization</b>: the top-level object that models a Chkk customer.

    * <b>Account</b>: a container for resource ownership within an Organization.

    * <b>KubePlatform</b>: describes things like the cloud infrastructure
    provider
      and the control plane provider.
    * <b>KubeCluster</b>: a single cluster provisioned by a
      KubePlatform.
    * <b>KubeClusterScan</b>: a single Chkk scan of a cluster.

    * <b>KubeClusterResource</b>: a single Resource
      (Deployment, DaemonSet or StatefulSet) from a KubeClusterScan.
    * <b>KubeClusterResourceContainer</b>: a single container record in a
      KubeClusterResource.
    * <b>Project</b>: software that provides some functionality.

    * <b>ProjectReleaseSeries</b>: a single release series for a Project.

    * <b>ProjectRelease</b>: a single release for a Project.

    * <b>ProjectVersionSet</b>: a configuration, layout or structure of a
    Project
      that is consistent for a range of ProjectReleases.
    * <b>ProjectComponent</b>: a separate binary, daemon, or subsystem of a
      Project.
    * <b>Package</b>: a named bundle of software that is bundled (and
      identified) in the format of a specific PackageSystem.
    * <b>PackageRelease</b>: a single release for a Package.

    * <b>PackageVersionSet</b>: a configuration, layout or structure of a
    Package
      that is consistent for a range of PackageReleases.
    * <b>OCIRepository</b>: a single namespace within an OCI Registry.

    * <b>OCIArtifact</b>: a single OCI Artifact (manifest) that describes an OCI
      Image or other OCI Artifact.
    * <b>OCITag</b>: a name that points to a unique OCIArtifact within an
      OCIRepository.
    * <b>OCIReference</b>: a relationship between an OCITag and an OCIArtifact.

    * <b>RiskSignature</b>: the source of a <em>potential</em>
      availability or operational risk for a customer.
    * <b>Risk</b>: a <em>detected</em> RiskSignature for an Account.

    * <b>UpgradeTemplate</b>: detailed instructions for upgrading or migrating a
      KubeCluster or an installed part of a KubeCluster. 
  title: Chkk API
  version: '1.0'
servers: []
security: []
paths:
  /kubeclusters/{cluster}/resources:
    get:
      tags:
        - KubeCluster
      summary: List Resources
      description: >
        List multiple KubeClusterResources


        A KubeCluster can have many <em>KubeClusterResources</em>. Each time a

        KubeCluster's inventory is scanned, one or more KubeClusterResources are

        created for the KubeCluster and scan date.


        KubeClusterResource represents a single Resource (Deployment,

        Daemonset, StatefulSet, etc) installed in a specific namespace in

        the KubeCluster.


        A KubeClusterResource <em>may</em> be assigned a known
        KubeDeploymentSystem.

        When the KubeClusterResource's DeploymentSystem field is empty, that
        means that

        the classification process was unable to determine a matching

        KubeDeploymentSystem for the discovered Resource.


        A KubeClusterResource <em>may</em> be assigned a known PackageSystem.
        When the

        KubeClusterResource's PackageSystem field is empty, that means that the

        classification process was unable to determine a matching PackageSystem
        for the

        discovered Resource.


        A KubeClusterResource <em>may</em> be associated with a known Package.
        When the

        KubeClusterResource's Package field is empty, that means that the

        classification process was unable to determine a matching Package for
        the

        discovered Resource.


        A KubeClusterResource <em>may</em> be associated with a known
        PackageComponent.

        When the KubeClusterResource's PackageComponent field is empty, that
        means that

        the classification process was unable to determine a matching
        PackageComponent

        for the discovered Resource.
      operationId: kubecluster-resource-list
      parameters:
        - description: >-
            Continuation token value (used when retrieving the next page of
            results).
          explode: false
          in: query
          name: continue
          schema:
            description: >-
              Continuation token value (used when retrieving the next page of
              results).
            type: string
        - description: Number of records to show per page of results.
          explode: false
          in: query
          name: 'n'
          schema:
            description: Number of records to show per page of results.
            format: int64
            maximum: 100
            minimum: 0
            type: integer
        - description: Record filter.
          explode: false
          in: query
          name: filter
          schema:
            description: Record filter.
            type: string
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ListKubeClusterResourcesOutputBody'
          description: OK
        default:
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/ErrorModel'
          description: Error
components:
  schemas:
    ListKubeClusterResourcesOutputBody:
      additionalProperties: false
      properties:
        $schema:
          description: A URL to the JSON Schema for this object.
          examples:
            - >-
              https://example.com/schemas/ListKubeClusterResourcesOutputBody.json
          format: uri
          readOnly: true
          type: string
        pagination:
          $ref: '#/components/schemas/Pagination'
        results:
          items:
            $ref: '#/components/schemas/KubeClusterResource'
          type:
            - array
            - 'null'
      required:
        - results
      type: object
    ErrorModel:
      additionalProperties: false
      properties:
        $schema:
          description: A URL to the JSON Schema for this object.
          examples:
            - https://example.com/schemas/ErrorModel.json
          format: uri
          readOnly: true
          type: string
        detail:
          description: >-
            A human-readable explanation specific to this occurrence of the
            problem.
          examples:
            - Property foo is required but is missing.
          type: string
        errors:
          description: Optional list of individual error details
          items:
            $ref: '#/components/schemas/ErrorDetail'
          type:
            - array
            - 'null'
        instance:
          description: >-
            A URI reference that identifies the specific occurrence of the
            problem.
          examples:
            - https://example.com/error-log/abc123
          format: uri
          type: string
        status:
          description: HTTP status code
          examples:
            - 400
          format: int64
          type: integer
        title:
          description: >-
            A short, human-readable summary of the problem type. This value
            should not change between occurrences of the error.
          examples:
            - Bad Request
          type: string
        type:
          default: about:blank
          description: A URI reference to human-readable documentation for the error.
          examples:
            - https://example.com/errors/example
          format: uri
          type: string
      type: object
    Pagination:
      additionalProperties: false
      properties:
        continue:
          description: >-
            Continuation token value (used when retrieving the next page of
            results). Empty when no more records can be retrieved.
          type:
            - string
            - 'null'
      required:
        - continue
      type: object
    KubeClusterResource:
      additionalProperties: false
      properties:
        $schema:
          description: A URL to the JSON Schema for this object.
          examples:
            - https://example.com/schemas/KubeClusterResource.json
          format: uri
          readOnly: true
          type: string
        cluster:
          description: >-
            Cluster is the ID of the KubeCluster in which this
            KubeClusterResource resides.
          examples:
            - k8scl_83eaa8d5-36ab-4814-9559-77518ec434cf
          type: string
        deployment_system:
          description: >-
            During classification, if Chkk was able to determine what was used
            to deploy the resource, this field will contain the
            KubeDeploymentSystem that was identified.
          examples:
            - argocd
          type: string
        external_id:
          description: The value of the metadata.name field in the resource manifest.
          examples:
            - 2aabf5d0-2f5c-4736-9863-27fd8ab7a756
          type: string
        namespace:
          description: The namespace in which the KubeClusterResource resides.
          examples:
            - kube-system
          type: string
        package:
          description: >-
            During classification, if Chkk was able to determine the specific
            Package contained the resource, this field will contain the ID of
            the Package.
          examples:
            - pkg_8897b911-950d-4485-93a9-2eedc6fac4fa
          type: string
        package_component:
          description: >-
            During classification, if Chkk was able to determine the specific
            PackageComponent that was associated with the resource, this field
            will contain the ID of the PackageComponent.
          examples:
            - pkg_8897b911-950d-4485-93a9-2eedc6fac4fa:1:agent
          type: string
        package_system:
          description: >-
            During classification, if Chkk was able to determine what packaging
            system was used to bundle the resource, this field will contain the
            PackageSystem that was identified.
          examples:
            - helm
          type: string
        resource_kind:
          description: The Resource Kind.
          enum:
            - Deployment
            - DaemonSet
            - StatefulSet
          examples:
            - Deployment
          type: string
        resource_name:
          description: The value of the metadata.name field in the resource manifest.
          examples:
            - mysql-server
          type: string
        scanned_on:
          description: The timestamp the KubeClusterScan occurred.
          format: int64
          type: integer
      required:
        - cluster
        - scanned_on
        - namespace
        - resource_kind
        - resource_name
        - external_id
      type: object
    ErrorDetail:
      additionalProperties: false
      properties:
        location:
          description: >-
            Where the error occurred, e.g. 'body.items[3].tags' or
            'path.thing-id'
          type: string
        message:
          description: Error message text
          type: string
        value:
          description: The value at the given location
      type: object

````